import processing.video.*;
import deadpixel.revkeystone.*;

Movie myMovie;

ReverseKeystone rks;
ReverseCornerPinSurface surface;
boolean doDraw = false;
PGraphics camOffscreen;
boolean doDisplayCamera = true;

void setup(){
  size(1024,768,P3D);
  
  rks = new ReverseKeystone(this); 
  surface = rks.createReverseCornerPinSurface(226, 223, 5);

  
  myMovie = new Movie(this, "camview.mov");
  myMovie.loop();
  
  camOffscreen = createGraphics(226,223,P3D);
  
}

void draw(){

  background(255);
  //image(myMovie,0,0);
  //surface.render(myMovie);
  
  
  camOffscreen.beginDraw();
  camOffscreen.image(myMovie,0,0);
  surface.render(camOffscreen,myMovie);
  camOffscreen.endDraw();
  
  
  if(doDisplayCamera){
    image(camOffscreen,0,0);
  }
  
   for(int x = 0; x<camOffscreen.width; x++){
    for(int y = 0; y<camOffscreen.height; y++){
      color c = camOffscreen.get(x,y);
     float greenX = map(x,0,camOffscreen.width,0,width);
     float greenY = map(y,0,camOffscreen.height,0,height);
      if(green(c) > 150){
        ellipse(greenX,greenY,10,10);
      }
    }
  }
  
  
  

  


}

void keyPressed(){
  
  //println(key);
  if(key == 'c'){
    rks.toggleCalibration();
  }
  else if(key == 'r'){
    rks.makeRectangular();
  }
  else if(key == 's'){
    rks.save();
  }
  else if(key == 'l'){
    rks.load();
  }
  else if(key == 't'){
    //make the camera image dissapear
    doDisplayCamera = false;
  }
  
  
}


void movieEvent(Movie myMovie) {
  myMovie.read();
}
